import { HttpClient, HttpEvent, HttpHeaders, HttpResponse } from '@angular/common/http';
import { Inject, Injectable, Optional } from '@angular/core';
import { Observable } from 'rxjs';

import { Configuration } from '../configuration';
import { Complaint } from '../model/complaint';
import { ResponseStats200 } from '../model/responseStats200';
import { BASE_PATH } from '../variables';

/**
 * Tankerkönig API
 * API for getting real time gas prices from https://creativecommons.tankerkoenig.de. Real time gas price data is available under open data/open source license even for commercial use. Currently only prices for Germany are available.
 *
 * OpenAPI spec version: 4.0.6
 * Contact: info@tankerkoenig.de
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */ /* tslint:disable:no-unused-variable member-ordering */

@Injectable()
export class TankerkoenigComplaintService {
  protected basePath = 'https://creativecommons.tankerkoenig.de/api/v4';
  public defaultHeaders = new HttpHeaders();
  public configuration = new Configuration();

  constructor(protected httpClient: HttpClient, @Optional() @Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
    if (basePath) {
      this.basePath = basePath;
    }
    if (configuration) {
      this.configuration = configuration;
      this.basePath = basePath || configuration.basePath || this.basePath;
    }
  }

  /**
   * Send a complaint with correction
   * There are several complaint types allowed, see complaint model. Correction depends on complaint type -- wrongPrice - the correct price as float. wrongPetrolLocation - correct location as LAT,LON (2 floats). Omitted for wrongStatus. For all others - corrected value
   * @param body Content of complaint with corrrection
   * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
   * @param reportProgress flag to report request and response progress.
   */
  public complaintPost(body?: Complaint, observe?: 'body', reportProgress?: boolean): Observable<ResponseStats200>;
  public complaintPost(body?: Complaint, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<ResponseStats200>>;
  public complaintPost(body?: Complaint, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<ResponseStats200>>;
  public complaintPost(body?: Complaint, observe: any = 'body', reportProgress: boolean = false): Observable<any> {
    let headers = this.defaultHeaders;

    // to determine the Accept header
    let httpHeaderAccepts: string[] = ['application/json; charset=utf-8'];
    const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
    if (httpHeaderAcceptSelected != undefined) {
      headers = headers.set('Accept', httpHeaderAcceptSelected);
    }

    // to determine the Content-Type header
    const consumes: string[] = ['application/json'];
    const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
    if (httpContentTypeSelected != undefined) {
      headers = headers.set('Content-Type', httpContentTypeSelected);
    }

    return this.httpClient.request<ResponseStats200>('post', `${this.basePath}/complaint`, {
      body: body,
      withCredentials: this.configuration.withCredentials,
      headers: headers,
      observe: observe,
      reportProgress: reportProgress,
    });
  }
}
